; Attribute Zone
; (public domain)
	inesmap 11 ; $8000-$FFFF: [CCCC ..PP]
	inesmir 1
	inesprg 2
	ineschr 1

;Tiles:
;  0=Empty   1=Wall   2=Key   3=Door   4=Box   5=Slider E/W   6=Slider N/S
;  7=One Step   8=Ball   9=Gem   10=Paintbrush   11=Gate   12=Bomb
;  13=Ghost Block   14=Puller   15=Water
;Sprites:
;  0=Player   1=Other Player   2=Pusher N   3=Pusher S   4=Pusher E
;  5=Pusher W   6=Ghost   7=Chaser   8=Runner N   9=Runner S   10=Runner E
;  11=Runner W   12=Rock   13=Bubble   14=Timer H   15=Timer V

t0	= $000
t1	= $001
t2	= $002
t3	= $003
t4	= $004
t5	= $005
t6	= $006
t7	= $007
t8	= $008
t9	= $009
t10	= $00A
t11	= $00B
t12	= $00C
t13	= $00D
t14	= $00E
t15	= $00F
t16	= $035
t17	= $036
t18	= $037
t19	= $038
t20	= $039
t21	= $03A
t22	= $03B
t23	= $03C
t24	= $03D
t25	= $03E
t26	= $03F

gstate	= $010 ; 0=pushed 1=unpushed
kstate0	= $011
kstate1	= $012
kstate2	= $013
kstate3	= $014
kstate4	= $015
kstate5	= $016
kstate6	= $017
kstate7	= $018
kstate8	= $019

gdown	= $020 ; 1=pushed just now
kdown0	= $021
kdown1	= $022
kdown2	= $023
kdown3	= $024
kdown4	= $025
kdown5	= $026
kdown6	= $027
kdown7	= $028
kdown8	= $029

compbyt	= $01A
compcnt	= $01B

blink	= $01C
pputrig	= $01D

levnum	= $01F
gridpar	= $01E
havekey	= $02A
levmus	= $02B
iscust	= $02C
objcnt	= $0E0

dpcntl	= $02E
dpcnth	= $02F

musl	= $030
mush	= $031
musdel	= $032
musnw	= $033
mushs	= $034

oam	= $200
oambak	= $300
nametab	= $400

ycursor	= $200
xcursor	= $203
yplayer	= $201
xplayer	= $203

	code

	bank 1,"Data"
	bank 0,"Data"
	org $8000
ident	ds 256
ektabha	ds 256
ektabla	ds 256
	include "levelptr.inc"

	macro ektab_set
	if ?X=1
	macset 2,4,*
	macset 3,4,?B
	bank 0
	org ektabha+(\1)
	db high((\2)-1)
	org ektabla+(\1)
	db low((\2)-1)
	bank \3
	org \2
	endif
	endm

	; Music data
tone	incbin "tone.bin"
song1	incbin "song1.bin"
song2	incbin "song2.bin"
song3	incbin "song3.bin"
song4	incbin "song4.bin"
	ds low(256-*) ; Skip to next 256-byte page
endsong	= *

	; Tape writing routines

	; Short delay
shortd	ldx #$47
	dex
	bne longd1

	; Long delay
longd	ldx #$91
longd1	dex
	bne longd1
	rts

	; Send "0" bit
send0	lda #2
	sta $4016
	jsr longd
	lsr a
	sta $4016
	jsr longd
	lsr a
	sta $4016
	rts

	; Send carry bit
sendcb	bcc send0
	; fall through

	; Send "1" bit
send1	lda #2
	sta $4016
	jsr shortd
	lsr a
	sta $4016
	jsr shortd
	asl a
	sta $4016
	jsr shortd
	lsr a
	sta $4016
	jsr shortd
	lsr a
	sta $4016
	rts

	; Send leader tone
slead	lda #$21
	sta <t1 ; Use <t1 for loop counting up to 256
	ldy #0
slead1	jsr send1
	dey
	bne slead1
	dec <t1
	bne slead1
	clc
	rts	

	; Send a byte to the tape (from accumulator)
sndbyt	sta <t0
	jsr send0
	ldy #$08
sndbyt1	asl <t0
	jsr sendcb
	dey
	bne sndbyt1
	jsr send1
	jmp send1

	; Tape reading routines

	; Wait for audio level transition
altwait	ldy #0
altw1	iny
	beq altw2
	lda $4016
	and #$02
	eor <t0
	beq altw1
	eor <t0
	sta <t0 ; <t0 is level after transition
	rts
altw2	dey ; Y = $FF indicates timeout.
	rts

	; Count audio level transitions within forty loops
altcnt	ldx #40
	ldy #0
altc1	lda $4016
	and #$02
	eor <t0
	beq altc2
	eor <t0
	sta <t0
	iny
	dex
	bne altc1
	rts ; Y = number of transitions
altc2	lda <t2
	lda <t1
	lda <t0
	dex
	bne altc1
	rts

	; Receive a leader tone
rlead	lda #$04
	sta $4016 ; enable tape reading
	ldx #0
	stx <t0
rlead1	jsr altwait
	cpy #$12
	bcc rlead
	cpy #$1A
	bcs rlead
	inx
	bne rlead1
	rts

	; Receive a byte (into accumulator)
	; Set carry flag in case of bad transmission
rcvbyt	lda $4016
	and #$02
	beq rcvbyt ; waiting for rising edge
recvb1	lda $4016
	and #$02
	bne recvb1 ; waiting for falling edge
	sta <t0 ; Now accumulator is zero
	jsr altwait
recvb2	sty <t3 ; <t3 is timing result
	jsr altwait
	tya
	clc
	adc <t3
	bcs recvb2 ; too long; try again
	cmp #$50
	bcc recvb2 ; too short; try again
	lda #8
	sta <t4 ; counter
recvb3	jsr altcnt
	cpy #4
	bcs recvb5 ; bad transmission
	cpy #2
	rol <t1
	tya
	lsr a
	bcs recvb4
	jsr altwait ; wait on even/odd frames
recvb4	jsr altwait
	dec <t4
	bne recvb3
	lda <t1
	clc
recvb5	rts

	bank 2,"Program"
	org $0050

	; Self-modifying-code area

	; Update PPUCTRL
smod0	lda #$80
ppuctrl	= *-1
	sta $2000

	; Calculate "ppuadd"
	and #$04
	asl a
	asl a
	asl a
	sta <ppuadd1
	eor #$38
	sta <ppuadd2

	; Update nametables
	ldx #$00
wcount	= *-1
	beq smod2
	lda #$23
ppuah	= *-1
	sta $2006
	eor #$24
	sta <ppuah1
	lda #$FE
ppual	= *-1
	sta $2006
	sta <ppual1
smod1	lda $0000
ppuah1	= *-1
ppual1	= *-2
	sta $2007
	lda <ppual1
ppuadd2	clc
	adc #0
ppuadd1	= *-1
	sta <ppual1
	lda <ppuah1
	adc #0
	sta <ppuah1
	dex
	bne smod1
smod2	lda #0

	; Update at address B
	lda #$23
ppubh	= *-1
	sta $2006
	eor #$24
	sta <ppubh1
	ldx #$FE
ppubl	= *-1
	stx $2006
	lda $0000,x
ppubh1	= *-1
	sta $2007

	; Update at address C
	lda #$23
ppuch	= *-1
	sta $2006
	eor #$24
	sta <ppuch1
	ldx #$FC
ppucl	= *-1
	stx $2006
	lda $0000,x
ppuch1	= *-1
	sta $2007

	; Update scroll positions
	lda #$00
xscroll	= *-1
	sta $2005
	lda #$00
yscroll	= *-1
	sta $2005

	; End of self-modifying code area
	jmp nmi1
	db 176,177,178,219,178,177,176

	org $C0D0

	; Set music
music	sty <musdel
	lda #$4B
	sta $4015
	sta $4017
	lda #$10
	sta <musdel
	sta $4000
	sta $4004
	sta $400C
	lsr a
	sta $4001
	sta $4005
	stx <musl
	sty <mush
	sty <mushs
	rts

	; Read one bit from CHR ROM into carry flag
getbit	lda <compcnt
	bne getbit1
	lda $2007
	sta <compbyt
	lda #8
	sta <compcnt
getbit1	dec <compcnt
	asl <compbyt
	rts

	; Macro for reading input
	macro read_inp_g
	lda $4016
	lsr a
	rol <gstate
	endm

	macro read_inp_k
	lda $4017
	lsr a
	and #$0F
	sta <kstate\1
	sty $4016
	lda $4017
	asl a
	asl a
	asl a
	and #$F0
	ora <kstate\1
	sta <kstate\1
	stx $4016
	endm

	; Subroutine to reset input
resetin	jsr readin
	; fall through

	; Subroutine for reading input
readin	ldx #$0A
readin1	lda <gstate-1,x
	sta <gdown-1,x
	dex
	bne readin1
	; Read input
	ldx #$05
	stx $4016
	dex
	stx $4016
	ldy #$06
	read_inp_g
	read_inp_g
	read_inp_g
	read_inp_g
	read_inp_g
	read_inp_g
	read_inp_g
	read_inp_g
	lda <gstate
	eor #$FF
	sta <gstate
	read_inp_k 0
	read_inp_k 1
	read_inp_k 2
	read_inp_k 3
	read_inp_k 4
	read_inp_k 5
	read_inp_k 6
	read_inp_k 7
	read_inp_k 8
	; Set *down registers
	ldx #$0A
readin2	lda <gstate-1,x
	eor #$FF
	and <gdown-1,x
	sta <gdown-1,x
	dex
	bne readin2
	rts

	; NMI routine
nmi	pha
	txa
	pha
	tya
	pha

	; Run self-modifying code area
	jmp smod0

	; Update PPUCTRL again if necessary
nmi1	lda <ppuctrl
	sta $2000

	; Write OAM data
	lda #high(oam)
	sta $4014

	; Update PPU trigger
	ldx #0
	stx <pputrig
	stx <wcount

	; Run music
mus0	lda <musdel
	beq mus1
	dec <musdel
	jmp nmi3
mus1	tay
	lax [musl],y
	inc <musl
	lda [musl],y
	inc <musl
	bne mus2
	inc <mush
mus2	cpx #musl
	bcc mus3
	sta <0,x
mus3	sta $4000,x
	cpx #musl
	bne mus4
	lda <mushs
	sta <mush
mus4	cpx #musnw
	bne mus0
	; Load current musical note
	lsr a
	lsr a
	tax
	lda <musnw
	and #$03
	asl a
	asl a
	tay
	lda tone,x
	sta $4002,y
	lda tone+64,x
	sta $4003,y
	jmp mus0

	; Cursor blink
nmi3	dec <blink
	bne nmi2
	lda #$0D
	sta <blink
	lda oam+2
	eor #$FF
	sta oam+2
	
	; End of NMI routine
nmi2	pla
	tay
	pla
	tax
	pla
	rti

	; Load nametable
ntload	ldx #$00
	stx $2000
	stx $2001
	lda #$20
	sta $2006
	stx $2006
ntload1	lda $400,x
	sta $2007
	inx
	bne ntload1
ntload2	lda $500,x
	sta $2007
	inx
	bne ntload2
ntload3	lda $600,x
	sta $2007
	inx
	bne ntload3
ntload4	lda $700,x
	sta $2007
	inx
	bne ntload4
	lda <ppuctrl 
	sta $2000
	lda #$1E
	sta $2001
	rts

	; Palette data (backward)
palette	db $29,$19,$09,$1D ; Objects 3 (reserved)
	db $2E,$1E,$0E,$1D ; Objects 2 (cursor off)
	db $3C,$2D,$23,$1D ; Objects 1 (cursor on)
	db $2B,$1B,$0B,$1D ; Objects 0 (game pieces)
	db $20,$15,$03,$1D ; Background 3 (red)
	db $20,$28,$03,$1D ; Background 2 (yellow)
	db $20,$2A,$03,$1D ; Background 1 (green)
	db $20,$11,$03,$1D ; Background 0 (blue)

	; Title screen
	;  '01234567890123456789012345678901'
titlesc	db "+-                            -+"
	db "|                              |"
	db "                                "
	db "                                "
	db "                                "
	db "                                "
	db "                                "
	db "         ATTRIBUTE ZONE         "
	db "                                "
	db "                                "
	db "                                "
	db "   LEVEL: _                     "
	db "                                "
	db "                                "
	db "                                "
	db "   START = PLAY ROM LEVELS      "
	db "    F1   = PLAY ROM LEVELS      "
	db "    F2   = PLAY FROM TAPE       "
	db "    F3   = EDIT FROM TAPE       "
	db "    F4   = EDIT NEW LEVEL       "
	db "                                "
	db "                                "
	db "                                "
	db "                                "
	db "                                "
	db "                                "
	db "                                "
	db "                                "
	db "|                              |"
	db "+-                            -+"

	; Reset
	ektab_set $09 ;stop
reset	ldx #$FF
	sei
	txs

	; Turn off PPU (in case of RESET button pushed)
	inx
	stx $2000
	stx $2001

	; Wait for PPU
	bit $2002
vwait1	bit $2002
	bpl vwait1

	; RAM signature
	lda #'K'
	pha
	lda #'C'
	pha
	lda #'A'
	pha
	lda #'L'
	pha
	lda #'B'
	pha
	lda #'.'
	pha
	lda #'N'
	pha
	lda #'O'
	pha
	lda #'R'
	pha
	lda #'A'
	pha
	pha
	txa
	pha
	pha
	pha
	pha
	pha

	; Initialize OAM
	lda #$FF
initoam	sta oam,x
	inx
	bne initoam

	; Select music
	ldx #low(song1)
	ldy #high(song1)
	jsr music

	; Reset keyboard state
	jsr resetin

	; Wait for PPU
	bit $2002
vwait2	bit $2002
	bpl vwait2

	; Bank select, and clear carry and accumulator
	clc
	rla ident

	; Clear RAM
	sta <levnum
	sta <pputrig
	sta <gridpar
	sta <iscust
	lda #$05
	sta <blink

	; Load title screen
	ldx #$00
	lda #$20
	sta $2006
	stx $2006
titl1	lda titlesc+$000,x
	sta $400,x
	sta $2007
	inx
	bne titl1
titl2	lda titlesc+$100,x
	sta $500,x
	sta $2007
	inx
	bne titl2
titl3	lda titlesc+$200,x
	sta $600,x
	sta $2007
	inx
	bne titl3
titl4	lda titlesc+$300,x
	sta $700,x
	sta $2007
	inx
	bne titl4

	; Load self-modifying-code area
	ldx #smod0
lsmod	lda $C000,x
	sta <$00,x
	inx
	bne lsmod

	; Load blank nametable mirrors
	lda #$04
	sta $2000
	lda #$24
	sta $2006
	ldy #$1F
	sty $2006
	iny
	ldx #$E0
lbntm	sty $2007
	inx
	bne lbntm
	stx $2000

	; Load palette
	ldx #$20
	ldy #$3F
	sty $2006
	iny
	sty $2006
lpal	lda palette-1,x
	sta $2007
	dex
	bne lpal

	; Initialize title screen program
	stx <t0 ; Level number cursor position
	stx <t1 ; Level number digit
	stx <t2 ; Digit is currently active
	stx <t3 ; Misc
	lda #$21
	sta <ppuah
	lda #$6A
	sta <ppual

	; Enable rendering
	lda #$1E
	sta $2001
	lda #$80
	sta $2000

	; Run title screen
runtitl	lda #$04
	sta <wcount
	jsr readin
	lda <kstate7
	and #$09 ; CTR
	eor #$01 ; test if the keyboard is even present
	bne runtit1
	jmp dpcmkey
runtit1	ldy #$00
	lda <gdown
	cmp #$10 ; START
	beq titlef1
	bit ident+$60 ; B or SELECT
	bne restitl
	bit ident+$81 ; A or RIGHT
	bne nxtdig
	bit ident+$08 ; UP
	bne updigit
	and #$04 ; DOWN
	bne dndigit
	lda #$01
	bit <kdown3
	bmi digit8
	bvs digit9
	bit <kdown4
	bmi digit6
	bvs digit7
	bne titlef4
	bit <kdown5
	bmi digit4
	bvs digit5
	bne titlef3
	bit <kdown6
	bmi digit3
	bne titlef2
	bit <kdown7
	bmi digit2
	bvs digit1
	bne titlef1
	bit <kdown2
	bmi digit0
	lda <kdown8
	and #$41 ; DEL or CLR HOME
	beq runtitl

	; Reset title screen
restitl	brk

	; F1 key
titlef1	lda <levnum
	eor #$FF
	sta <levmus
startle	jsr romlvl
	jmp playlvl

	; Next digit
nxtdig	lda <t2
	beq runtitl
	jsr anxtdig
	jmp runtitl

	; Up digit
updigit	jsr actdig
	bcc jrunt
	ldx <t0
	lda #9
	cmp <t1
	beq jrunt
	inc $56A,x
	inc <t1
	inc <levnum
	beq dndigit
	bne jrunt

	; Down digit
dndigit	jsr actdig
	bcc jrunt
	lda <t1
	beq jrunt
	ldx <t0
	dec $56A,x
	dec <t1
	dec <levnum
jrunt	jmp runtitl

	; F2 key
titlef2	jmp ptaplvl

	; F3 key
titlef3	jmp etaplvl

	; F4 key
titlef4	jmp eblklvl

	; Pushed a number key
digit9	iny
digit8	iny
digit7	iny
digit6	iny
	lda <levnum
	cmp #25
	bcs jrunt
digit5	iny
digit4	iny
digit3	iny
digit2	iny
digit1	iny
digit0	lda <t0
	cmp #3
	beq jrunt
	lda <levnum
	cmp #26
	bcs jrunt
	jsr multen
	ldx <t0
	tya
	adc #'0'
	sta $56A,x
	adc <levnum
	sec
	sbc #'0'
	sta <levnum
	jsr anxtdig
	jmp runtitl

	; Cursor to next position
anxtdig	lda #$00
	sta <t1
	sta <t2
	lda #'_'
	inc <t0
	ldx <t0
	sta $56A,x
actrts	rts

	; Activate digit position (if applicable)
actdig	lda <t2
	ror a
	bcs actrts ; Already active
	ldx <t0
	cpx #3
	clc
	beq actrts
	lda <levnum
	cmp #26
	clc
	bpl actrts
	inc <t2
	lda #'0'
	sta $56A,x

	; Multiply level number by ten
multen	asl <levnum
	lda <levnum
	asl a
	asl a
	adc <levnum
	sta <levnum
	rts

	; Load and play tape level
ptaplvl	jsr ptape
	; fall through

	; Prepare level for playing
	ektab_set $3A ;F1
	jsr oamsort
	ldy #$FF
	sty ycursor
	iny
	tya

	; Clear sprite counters
	ldx #objcnt
prep1	sta <0,x
	inx
	bne prep1

	; Count sprites
prep2	lda oam,y
	lsr a
	lsr a
	lsr a
	tax
	inc objcnt-1,x
	iny
	iny
	iny
	iny
	bne prep2

	; Lose all keys
	sty <havekey

	; Set custom level flag
	dey
	sty <iscust

	; Select music for custom levels
	;ldx #low(song7)
	;ldy #high(song7)
	;jsr music

	; Play ROM level or tape level
playlvl	jsr readin
	ldx #0
	ldy #0
	lda <kstate0
	bne playl08 ; skip gamepad reading if keyboard is present
	lda <gdown
	bpl playl01
	;A
playl51	jmp swiplay
playl01	asl a
	bpl playl02
	;B
playl52	jmp expall
playl02	asl a
	bpl playl03
	;SELECT
playl53	brk
playl03	asl a
	bpl playl04
	;START
playl54	jmp startle
playl04	ldx #$00
	asl a
	bpl playl05
	;UP
playl55	ldy #$FF
	jmp movplay
playl05	ldy #$01
	asl a
	bpl playl06
	;DOWN
playl56	jmp movplay
playl06	dey
	asl a
	bpl playl07
	;LEFT
playl57	ldx #$FF
	jmp movplay
playl07	asl a
	bpl playl08
	;RIGHT
playl58	ldx #$01
	jmp movplay
playl08	lda <kdown0
	cmp #$02
	;RETURN
	beq playl54
	cmp #$04
	bne playl09
	;[
	dec <levnum
	jmp startle
playl09	cmp #$08
	bne playl10
	;]
	inc <levnum
	jmp startle
playl10	lda <kdown2
	cmp #$08
	;K
	beq playl55
	eor #$04
	eor <kdown8
	;L or RIGHT
	beq playl58
	lda #$08
	iny
	cmp <kdown3
	;J
	beq playl56
	dey
	eor <kdown4
	eor <kdown8
	;H or LEFT
	beq playl57
	lda <kdown6
	cmp #$20
	;Z
	beq playl51
	cmp #$10
	;X
	beq playl52
	lda #$01
	cmp <kdown5
	;F3
	beq editor
	cmp <kdown7
	;F1
	beq playl53
	lda <kdown8
	cmp #$02
	;UP
	beq playl55
	iny
	cmp #$10
	;DOWN
	beq playl56
	jmp playlvl

	; Load and edit tape level
etaplvl	jsr ptape
	jmp editor

	; Load and edit blank level
	ektab_set $22 ;F4
eblklvl	jsr mkblank
	; fall through

	; Load editor
editor	ldx #low(song2)
	ldy #high(song2)
	jsr music
	jsr ntload
	ldx #$10
	stx oam+1
	dex
	stx oam+0
	inx
	stx oam+3
	inx
	stx oam+2

	; Read the keyboard for editor function
editkey	jsr readin
	lda <kstate0
	lsr a
	and <kstate7
	and #$10
	beq editshf
	lda <kstate7
	and #$08
	beq editctr
	ldy #$00
	jmp editknu

	; Read editor keys with SHIFT pushed
editshf	lda <kstate4
	and <kstate8
	and #$08
	bne editsh1
	jmp ek_clf
editsh1	lda <kstate2
	and <kstate8
	and #$04
	bne editsh2
	jmp ek_crt
editsh2	lda <kstate8
	asl a
	asl a
	and <kstate2
	and #$08
	bne editsh3
	jmp ek_cup
editsh3	lda <kstate8
	lsr a
	and <kstate3
	ldy #$50
	and #$08
	bne editknu
	jmp ek_cdn

	; Read editor keys with CONTROL pushed
editctr	ldy #$A0
	; fall through

	; Read a key number for editor
editknu	ldx #$00
	lda <kdown0
	bne editkn1
	ldx #$08
	lda <kdown1
	bne editkn1
	ldx #$10
	lda <kdown2
	bne editkn1
	ldx #$18
	lda <kdown3
	bne editkn1
	ldx #$20
	lda <kdown4
	bne editkn1
	ldx #$28
	lda <kdown5
	bne editkn1
	ldx #$30
	lda <kdown6
	bne editkn1
	ldx #$38
	lda <kdown7
	bne editkn1
	ldx #$40
	lda <kdown8
	bne editkn1
	jmp editkey
editkn1	lsr a
	inx
	bcc editkn1
	adc ident,x
	adc ident,y
	tax
	lda ektabha,x
	pha
	lda ektabla,x
	pha
	rts

	; Converts cursor position to (X,Y); leaves A alone.
curconv	pha
	lda xcursor
	lsr a
	lsr a
	lsr a
	tax
	dex
	lda ycursor
	lsr a
	lsr a
	lsr a
	tay
	dey
	pla
	rts

	; Cursor down
	ektab_set $46 ;down
	ektab_set $1D ;J
ek_cdn	lda ycursor
	cmp #$D7
	beq ek2cdn
	adc #$08
	sta ycursor
ek2cdn	lda <kstate0
	alr #$20
	and <kstate7
	bne ek3cdn
	jsr frwait ; Wait a frame before repeating if the SHIFT key is pushed
ek3cdn	jmp editkey

	; Cursor up
	ektab_set $43 ;up
	ektab_set $15 ;K
ek_cup	lda ycursor
	cmp #$0F
	beq ek2cdn
	sbc #$08
	sta ycursor
	jmp ek2cdn

	; Cursor left
	ektab_set $45 ;left
	ektab_set $25 ;H
ek_clf	lda xcursor
	cmp #$08
	beq ek2cdn
	sbc #$08
	sta xcursor
	jmp ek2cdn

	; Cursor right
	ektab_set $44 ;right
	ektab_set $14 ;L
ek_crt	lda xcursor
	cmp #$F0
	beq ek2cdn
	adc #$08
	sta xcursor
	jmp ek2cdn

	; X parity reset
	ektab_set $72 ;shift+F4
	lda <gridpar
	eor #$01
	sta <gridpar
	jmp eblklvl

	; Y parity reset
	ektab_set $C2 ;ctr+F4
	lda <gridpar
	eor #$20
	sta <gridpar
	jmp eblklvl

	; Save to tape
	ektab_set $1A ;F5
	ldx #$01
	stx $2000 ; NMI off
	stx $2001 ; Grayscale mode
	dex
	stx <t8 ; Address counter
	jsr oamsort
	jsr slead
	lda <gridpar
	jsr sndbyt
	lda <xscroll
	jsr sndbyt
	lda <yscroll
	jsr sndbyt
save1	ldx <t8
	lda $500,x
	jsr sndbyt
	ldx <t8
	lda $600,x
	jsr sndbyt
	ldx <t8
	lda $700,x
	jsr sndbyt
	ldx <t8
	lda $400,x
	jsr sndbyt
	ldx <t8
	lda $200,x
	jsr sndbyt
	dec <t8
	bne save1
	jsr ntload
	jmp editkey

	; Sort OAM entries
	ektab_set $6A ;shift+F5
	jsr oamsort
	jmp editkey

	; Plot/unplot a wall
	ektab_set $47 ;space
	jsr curconv
	jsr gridad
	lda [t10],y
	and #$1F
	php
	pla
	lsr a
	and #$01
	jsr curconv
	jsr upds
	jmp editkey

	; Plot a white piece
	ektab_set $1B ;I
	iny
	ektab_set $1C ;U
	iny
	ektab_set $23 ;Y
	iny
	ektab_set $2B ;T
	iny
	ektab_set $2C ;R
	iny
	ektab_set $38 ;E
	iny
	ektab_set $33 ;W
	iny
	ektab_set $3C ;Q
	iny
	ektab_set $21 ;8
	iny
	ektab_set $28 ;7
	iny
	ektab_set $29 ;6
	iny
	ektab_set $30 ;5
	iny
	ektab_set $31 ;4
	iny
	ektab_set $39 ;3
	iny
	ektab_set $41 ;2
	iny
	ektab_set $40 ;1
	sty <t8
	jsr curconv
	lda <t8
	jsr upds
	jmp editkey

	; Set up the current color (in high 2 bits of <t9)
	ektab_set $27 ;V
	iny
	ektab_set $2F ;C
	iny
	ektab_set $36 ;X
	iny
	ektab_set $37 ;Z
	tya
	lsr a
	ror a
	ror a
	ora #$10
	sta <t9
	jmp editkey

	; Change color at position
	ektab_set $77 ;shift+V
	iny
	ektab_set $7F ;shift+C
	iny
	ektab_set $86 ;shift+X
	iny
	ektab_set $87 ;shift+Z
	tya
	jsr curconv
	jsr scolor
	jmp editkey

	; Plot a color piece
	ektab_set $6B ;shift+I
	iny
	ektab_set $6C ;shift+U
	iny
	ektab_set $73 ;shift+Y
	iny
	ektab_set $7B ;shift+T
	iny
	ektab_set $7C ;shift+R
	iny
	ektab_set $88 ;shift+E
	iny
	ektab_set $83 ;shift+W
	iny
	ektab_set $8C ;shift+Q
	iny
	ektab_set $71 ;shift+8
	iny
	ektab_set $78 ;shift+7
	iny
	ektab_set $79 ;shift+6
	iny
	ektab_set $80 ;shift+5
	iny
	ektab_set $81 ;shift+4
	iny
	ektab_set $89 ;shift+3
	iny
	ektab_set $91 ;shift+2
	iny
	sty <t0
	jsr curconv
	lda <t0
	and #$0F
	ora <t9
	sta <t8
	jsr upds
	sty <t14
	jmp editkey

	; Plot a sprite
	ektab_set $BB ;ctr+I
	iny
	ektab_set $BC ;ctr+U
	iny
	ektab_set $C3 ;ctr+Y
	iny
	ektab_set $CB ;ctr+T
	iny
	ektab_set $CC ;ctr+R
	iny
	ektab_set $D8 ;ctr+E
	iny
	ektab_set $D3 ;ctr+W
	iny
	ektab_set $DC ;ctr+Q
	iny
	ektab_set $C1 ;ctr+8
	iny
	ektab_set $C8 ;ctr+7
	iny
	ektab_set $C9 ;ctr+6
	iny
	ektab_set $D0 ;ctr+5
	iny
	ektab_set $D1 ;ctr+4
	iny
	ektab_set $D9 ;ctr+3
	iny
	ektab_set $E1 ;ctr+2
	iny
	ektab_set $E0 ;ctr+1
	tya
	and #$0F
	pha
	jsr curconv
	jsr oxyfind
	bne plspr2 ; otherwise, X=0
plspr1	lda oam,x
	cmp #$FF
	beq plspr2
	txa
	axs #$FC
	bne plspr1
plspr2	pla
	sta oam+1,x
	lda <t22
	sta oam+3,x
	lda <t23
	sta oam,x
	lda #0
	sta oam+2,x
	jmp editkey

	; Delete both a sprite and a tile
	ektab_set $48 ;delete
	jsr curconv
	lda #0
	jsr upds
	; fall through

	; Delete a sprite
	ektab_set $2D ;D
	jsr curconv
	jsr oxyfind
	beq delspr1
	lda #$FF
	sta oam,x
delspr1	jmp editkey

	; Delete all sprites
	ektab_set $7D ;shift+D
	lda #$FF
	ldx #4
delspr2	sta oam,x
	inx
	bne delspr2
	jmp editkey

	; Rectangular fill up
	ektab_set $2E ;F
	jsr curconv
	stx <t0
	sty <t1
	ldy <t14
	ldx <t15
	cpx <t0
	bcc rctfil1
	txa
	ldx <t0
	sta <t0
rctfil1	cpy <t1
	bcc rctfil2
	tya
	ldy <t1
	sta <t1
rctfil2	stx <t2
	inc <t0
	inc <t1
rctfil3	lda <t8
	jsr updf
	inx
	cpx <t0
	bne rctfil3
	ldx <t2
	iny
	cpy <t1
	bne rctfil3
	jsr ntload
	jmp editkey

	; Subroutine to sort OAM:

	; Set up registers
oamsort	lda #0
	sta <t0 ;X coordinate
	sta <t1 ;Y coordinate
	ldy #4 ; keep track of next place to add to

	; Loop through all X/Y positions
oamsor2	jsr oamfind ; Find at (<t0,<t1)
	beq oamsor3
	lda oam,x
	sta oambak,y
	lda oam+1,x
	sta oambak+1,y
	lda oam+2,x
	sta oambak+2,y
	lda oam+3,x
	sta oambak+3,y
	iny
	iny
	iny
	iny
oamsor3	inc <t0
	lda <t0
	eor #30
	bne oamsor2
	sta <t0
	inc <t1
	lda <t1
	cmp #26
	bne oamsor2

	; Clear the rest of the OAM
	ldx #4
	tya
	beq oamsor5
	lda #$FF
oamsor4	sta oambak,y
	iny
	bne oamsor4

	; Copy new OAM to current OAM
oamsor5	lda oambak,x
	sta oam,x
	inx
	bne oamsor5

	; Finished
	rts

	; Find a sprite using X/Y registers as X/Y coordinates
	; Otherwise same as below.
oxyfind	stx <t0
	sty <t1
	;fall through

	; Find a sprite using <t0 and <t1 as X/Y coordinates
	; Stores result in A and X register; zero flag if not found
oamfind	ldx #$04
	lda <t0
	asl a
	asl a
	asl a
	adc #$08
	sta <t22
	lda <t1
	asl a
	asl a
	asl a
	adc #$0F
	sta <t23
oamfin1	lda oam,x
	cmp <t23
	bne oamfin2
	lda oam+3,x
	cmp <t22
	bne oamfin2
	txa ; to clear zero flag
	rts
oamfin2	txa
	axs #$FC
	bne oamfin1
	rts

	; Load data from tape
ptape	ldx #$01
	stx $2000 ; NMI off
	stx $2001 ; Grayscale mode
	dex
	stx $4015 ; Turn off music
	stx <t8 ; Address counter
	jsr rlead
	jsr rcvbyt
	sta <gridpar
	jsr rcvbyt
	sta <xscroll
	jsr rcvbyt
	sta <yscroll
ptape1	jsr rcvbyt
	ldx <t8
	sta $500,x
	jsr rcvbyt
	ldx <t8
	sta $600,x
	jsr rcvbyt
	ldx <t8
	sta $700,x
	jsr rcvbyt
	ldx <t8
	sta $400,x
	jsr rcvbyt
	ldx <t8
	sta $200,x
	dec <t8
	bne ptape1
	jmp ntload

	; Scroll Set
scrlset	lda <gridpar
	eor #$81
	and #$81
	sta <ppuctrl
	lda #$F8
	sta <xscroll
	lda #$E0
	sta <yscroll
	lda <gridpar
	lsr a
	bcc scrlse1
	lda #$00
	sta <xscroll
scrlse1	lda <gridpar
	and #$20
	beq scrlse2
	lda #$E8
	sta <yscroll
scrlse2	rts

	; mkblank:
	;   Make a blank level using the current grid parity setting

	; Clear the screen
mkblank	ldx #$00
	lda #$20
mkbl1	sta $400,x
	sta $500,x
	sta $600,x
	sta $700,x
	dex
	bne mkbl1

	; Set up scroll positions
	jsr scrlset

	; Fill in the grid area
	ldx #$00
	ldy #$00
mkbl2	lda #$00
	jsr updf
	inx
	cpx #30
	bne mkbl2
	ldx #$00
	iny
	cpy #26
	bne mkbl2

	; Clear OAM
	ldx #$04
	lda #$FF
mkbl3	sta $200,x
	inx
	bne mkbl3

	; Finished
mkbl9	rts

	; Update a cell (fast)
	; X,Y = coordinates (zero-based)
	; A = tile (low 5 bits = value, high 2 bits = color)
updf	and #$DF

	; Check in range
	cpx #30
	bcs mkbl9
	cpy #26
	bcs mkbl9

	; Save coordinates and get address
	pha
	stx <t15
	jsr gridad

	; Calculate background pattern
	lda <gridpar
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	adc <t14
	clc
	adc <t15
	eor #1
	eor <gridpar
	lsr <t15
	php
	rol <t15
	plp
	adc #0
	lsr a
	lsr a
	ror a
	lsr a
	sec
	ror a
	and #$A0
	sta <t12

	; Calculate and store tile code
	pla
	pha
	and #$1F
	ora <t12
	sta [t10],y

	; Calculate PPU high address
	lda <t11
	eor #$24
	sta <ppuah

	; Do colors if necessary
	pla
	ldy <t14
	bit ident+$10
	beq mkbl9
	asl a
	rol a
	rol a
	jmp scolor

	; Update a cell (slow)
upds	jsr updf
	lda <ppuctrl
	and #$04
	beq upds1
	lda <ppual
	and #$1F
	sta <ppual
	lda #$20
	sta <ppuah
	bne upds2
upds1	lda <ppual
	and #$E0
	sta <ppual
	lda #32
upds2	sta <wcount
	; fall through

	; Wait for next frame
frwait	dec <pputrig
frwait1	bit <pputrig
	bmi frwait1
	rts

	; Set color at position
	; X,Y = coordinates (zero-based)
	; A = color (low 2 bits only)
scolor	and #$03
	sta <t14
	lda #$03
	sta <t13
	jsr acolor
	lda <gridpar
	lsr a
	lda <t15
	adc #0
	and #$02
	beq scolor1
	asl <t14
	asl <t14
	asl <t13
	asl <t13
scolor1	lda <gridpar
	asl a
	asl a
	asl a
	tya
	adc #0
	and #$02
	beq scolor2
	asl <t14
	asl <t14
	asl <t13
	asl <t13
	asl <t14
	asl <t14
	asl <t13
	asl <t13
scolor2	lda $700,x
	ora <t13
	eor <t13
	ora <t14
	sta $700,x
	lda $300,x ; Used with decompression routines
	ora <t13
	sta $300,x
	ldx <t15
	rts

	; Get color at position
	; X,Y = coordinates (zero-based)
	; A = color (low 2 bits only; $10 and zero flag if white)
gcolor	jsr acolor
	lda $700,x
	pha
	ldx <t15
	jsr gridad
	pla
	tax
	lda [t10],y
	and #$10
	eor #$10
	bne gcolor3
	lda <gridpar
	lsr a
	lda <t15
	adc #0
	and #$02
	beq gcolor1
	txa
	lsr a
	lsr a
	tax
gcolor1	lda <gridpar
	asl a
	asl a
	asl a
	lda <t14
	adc #0
	and #$02
	beq gcolor2
	txa
	lsr a
	lsr a
	lsr a
	lsr a
	tax
gcolor2	txa
	and #$03
gcolor3	ldy <t14
	ldx <t15
	cmp #$10
	rts

	; Color address at position (result in X, old X in <t15)
acolor	lda <gridpar
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	adc ident,y
	asl a
	and #$F8
	ora #$C0
	sta <t15
	lda <gridpar
	anc #$01
	adc ident,x
	lsr a
	lsr a
	clc
	adc <t15
	stx <t15
	tax
	sta <ppubl
	lda #$23
	sta <ppubh
	rts

	; Calculate grid address (using X,Y)
	; (Y=0, result in <t10 and <t11, old Y in <t14)
	; (Also copied <t10 to <ppual; uses up <t12)
gridad	sty <t14
	sty <t12
	txa
	clc
	adc <gridpar
	ldy #0
	sty <t11 ; High address
	asl <t12
	rol <t11
	asl <t12
	rol <t11
	asl <t12
	sec
	rol <t11
	asl <t12
	rol <t11
	asl <t12
	rol <t11
	adc <t12
	sta <t10 ; Low address
	sta <ppual
	lda <t11
	adc #0
	sta <t11
	rts

	; Level decompression routines

	include "leveldec.inc"

	; Select bank/PPU
romlvl	lda #$01
	bit $2002
	sta $2000
	sta $2001
	ldx <levnum
	lda lvlptrh,x
	pha
	and #$1F
	sta $2006
	pla
	cpx #lvlsplt
	ror a
	tay
	sta ident,y
	lda lvlptrl,x
	sta $2006
	lda $2007

	; Check if custom levels
	lda <iscust
	beq romlvl0
	brk

	; Initialize
romlvl0	sta <gridpar
	sta <compcnt
	sta <havekey

	; Clear memory $3C0...$3CF and $0E0...$0FF
	ldx #$C0
romlvl1	sta $300,x
	cpx #$E0
	bcc romlvl2
	sta <0,x
romlvl2	inx
	bne romlvl1

	; Grid parity
	jsr getbit
	ror <gridpar
	lsr <gridpar
	lsr <gridpar
	lsr <gridpar
	jsr getbit
	rol <gridpar
	jsr mkblank

	; Background tiles
	ldy #1
	sty <t1
	ldx #$FF
	dey
nxbgt	inx
	cpx #30
	bne nxbgt1
	ldx #0
	iny
	cpy #26
	beq romlvl3
nxbgt1	dec <t1
	bne dectilp
	inc <t1
	jmp dectil

	; Colors
romlvl3	ldx #$C0
	ldy #8
romlvl4	lsr $300,x
	bcc romlvl5
	jsr getbit
romlvl5	ror $700,x
	dey
	bne romlvl4
	ldy #8
	inx
	bne romlvl4

	; Sprites
	lda #$0F
	sta <t0
	ldy #$04
	jmp decyp

	; Write tile
dectilr	sta <t1
	pla
dectilp	pha
	jsr updf
	pla
	jmp nxbgt

	; Write sprite
decsprp	ldx <t0
	cpx #$D7
	bcs decimu
	sta $201,y
	lda #0
	sta $202,y
	txa
	sta $200,y
	lsr a
	lsr a
	lsr a
	tax
	inc <objcnt-1,x
	iny
	iny
	iny
	iny
	jmp decyp

	; Decide music for ROM levels
decimu	lax <levnum
	eor <levmus
	stx <levmus ; don't restart the same song please
	and #$C0
	beq decimu5
	bit <levnum
	bvs decimu1
	bmi decimu2
	ldx #low(song3)
	ldy #high(song3)
	bpl decimu4
decimu1	bmi decimu3
	ldx #low(song4)
	ldy #high(song4)
	bpl decimu4
decimu2	;ldx #low(song5)
	;ldy #high(song5)
	bmi decimu4
decimu3	;ldx #low(song6)
	;ldy #high(song6)
decimu4	jsr music

	; Reset CHR bank and load nametables
decimu5	asl ident
	jmp ntload

	; Play game - explode all bombs
expall	ldx #0
	ldy #0
expall1	jsr gridad
	lda [t10],y
	ldy <t14
	and #15
	eor #12
	bne expall2
	dex
	jsr destroy
	inx
	dey
	jsr destroy
	iny
expall2	inx
	cpx #30
	bne expall1
	ldx #0
	iny
	cpy #26
	bne expall1
	ldy #0
expall3	jsr gridad
	lda [t10],y
	ldy <t14
	and #15
	eor #12
	bne expall4
	inx
	jsr destroy
	dex
	iny
	jsr destroy
	dey
	jsr destroy
expall4	inx
	cpx #30
	bne expall3
	ldx #0
	iny
	cpy #26
	bne expall3
	jmp nxturn

	; Play game - switch players
swiplay	ldx #4
swipl1	lda oam+1,x
	cmp #2
	bcs swipl2
	eor #1
	sta oam+1,x
swipl2	txa
	axs #$FC
	bne swipl1
	jmp nxturn

	; Play game - move the player
movplay	stx <t2
	sty <t3
	ldx #4
movpl1	lda oam+1,x
	stx <t16
	bne movpl2
	; Source and destination position
	lda oam+3,x
	lsr a
	lsr a
	lsr a
	clc
	sbc #0
	sta <t24
	clc
	adc <t2
	cmp #30
	bcs movpl2
	sta <t0
	lda oam,x
	lsr a
	lsr a
	lsr a
	clc
	sbc #0
	sta <t25
	clc
	adc <t3
	cmp #26
	bcs movpl2
	tax
	sta <t1
	; Is it already full?
	lda <t3
	beq movpl3 ; ignore if horizontal movement
	jsr oamfind
	bne movpl3 ; ignore if there is a sprite in the way
	lda <objcnt,x
	cmp #8
	bcs movpl2
	; Return ptr
movpl3	lda #high(puller-1)
	pha
	lda #low(puller-1)
	pha
	; Is there a sprite in the way?
	jsr oamfind
	beq movpl5
	ldy oam+1,x
	lda pmrsth,y
	pha
	lda pmrstl,y
	pha
	rts
	; It is a tile, then.
movpl5	ldx <t0
	ldy <t1
	jsr gcolor
	sta <t17
	ldy #0
	lda [t10],y
	and #$0F
	tay
	lda pmrtth,y
	pha
	lda pmrttl,y
	pha
	ldx <t16
	rts
movpl2	lax <t16
	axs #$FC
	bne movpl1
	; fall through

	; Next turn (X=0)
	; Finding player
nxturn	ldy oam,x
	iny
	beq nxturn2
	lda oam+1,x
	bne nxturn2
	tya
	lsr a
	lsr a
	lsr a
	clc
	sbc #1
	sta yplayer
	lda oam+3,x
	lsr a
	lsr a
	lsr a
	clc
	sbc #0
	sta xplayer
	ldx #4
	bne nxturn0
nxturn2	txa
	axs #$FC
	bne nxturn
	jmp deadly

	; Finding objects to move
nxturn0	ldy oam,x
	stx <t16
	iny
	beq nxturn1
	tya
	lsr a
	lsr a
	lsr a
	clc
	sbc #1
	sta <t25
	ldy oam+1,x
	lda oam+3,x
	lsr a
	lsr a
	lsr a
	clc
	sbc #0
	sta <t24
	lda #high(nxturn1-1)
	pha
	lda #low(nxturn1-1)
	pha
	lda autsth,y
	pha
	lda autstl,y
	pha
	rts
nxturn1	lax <t16
	axs #$FC
	bne nxturn0
	jmp playlvl

	; Move a puller from (<t24-<t2;<t25-<t3) in dir (<t2;<t3)
puller	lda <t24
	sec
	sbc <t2
	tax
	stx <t0
	lda <t25
	sec
	sbc <t3
	tay
	sty <t1
	jsr gridad
	lda [t10],y
	and #$0F
	eor #$0E
	bne puller1
	ldx <t0
	ldy <t1
	jsr movob
puller1	jmp movpl2

	; Figure out what color in the block, not counting one cell
	; Store old Y in <t14, results in <t4...<t7 and <t8
fcolor	lda #$00
	sta <t4
	sta <t5
	sta <t6
	sta <t7
	sta <t8
	jsr fcolor1
	jsr fcolor2
	; Toggle X
fcolor1	txa
	sec
	sbc <gridpar
	eor #1
	clc
	adc <gridpar
	tax
	jmp fcolor3
	; Toggle Y
fcolor2	lda <gridpar
	cmp #$20
	php
	tya
	adc #0
	eor #1
	tay
	plp
	bcc fcolor3
	dey
	; Read the color
fcolor3	cpx #30
	bcs fcolor4
	cpy #26
	bcs fcolor4
	jsr gcolor
	beq fcolor4
	tax
	inc <t8
	inc <t4,x
	ldx <t15
fcolor4	rts

	; Move an object at X,Y in direction given by <t2,<t3
	; New position in X,Y and carry flag set if unmovable
movob	stx <t20
	sty <t21
	jsr gridad
	lda [t10],y
	anc #$1F
	sta <t26
	txa
	adc <t2
	sta <t0
	cmp #30
	bcs movob_m
	lda <t21
	adc <t3
	sta <t1
	cmp #26
	bcs movob_m
	; It is on the board; now ensure it is vacant
	jsr oamfind
	bne movob_n
	; No sprites; look for occupation by tiles
	ldx <t0
	ldy <t1
	jsr gridad
	lda [t10],y
	and #$1F
	bne movob_n
	; Unoccupied; now check if colors are OK for moving
	ldx <t20
	ldy <t21
	jsr gcolor
	beq movob1 ; mover is white, so OK
	pha
	ldx <t0
	ldy <t1
	jsr fcolor
	pla
	tax
	lda <t4,x
	cmp <t8
	bne movob_n ; wrong color, so no good
	; It is OK; now move let's move it!
	txa
movob1	lsr a
	ror a
	ror a
	and #$C0
	ora <t26
	pha
	; Remove from old location
	lda #0
	ldx <t20
	ldy <t21
	jsr updf
	; Calculate new value of PPUCTRL register

	lda <ppuctrl
	and #$FB
	ldx <t2
	bne movob2
	ora #$04
movob2	sta <ppuctrl
	; Add to new location
	pla
	ldx <t0
	ldy <t1
	jsr upds
	clc
	rts
movob_n	sec
movob_m	ldx <t20
	ldy <t21
	rts

	; Move a sprite labeled by X in direction by <t2,<t3
	; Carry flag set if unmovable; retains X
movsp	stx <t4
	lda oam,x
	sec
	adc #0
	bcs movsp_m ; not existing sprite
	lsr a
	lsr a
	lsr a
	sbc #1
	sta <t5
	clc
	adc <t3
	cmp #26
	bcs movsp_m ; out of range
	sta <t1
	lda oam+3,x
	lsr a
	lsr a
	lsr a
	sbc #0
	clc
	adc <t2
	cmp #30
	bcs movsp_m ; out of range
	sta <t0
	; Check if space is occupied by sprites
	jsr oamfind
	sec
	bne movsp_m
	; Check if too many sprites on target row already
	ldx <t1
	lda <t3
	beq movsp1 ; if moving to same row, skip this check
	lda <objcnt,x
	cmp #8
	bcs movsp_m
	; Do moving
movsp1	inc <objcnt,x
	ldx <t5
	dec <objcnt,x
	ldx <t4
	lda <t2
	asl a
	asl a
	asl a
	clc
	adc oam+3,x
	sta oam+3,x
	lda <t3
	asl a
	asl a
	asl a
	clc
	adc oam,x
	sta oam,x
	clc
movsp_m	ldx <t4
	rts

	; Push an object at X,Y in direction <t2,<t3
	; Allow pushing multiple objects
pushing	stx <t18
	stx <t0
	sty <t19 ; start position
	sty <t1 ; current position
	; Find the end of the chain
pushi00	jsr oamfind
	bne pushi99
	ldx <t0
	ldy <t1
	jsr gridad
	lda [t10],y
	and #$0F
	beq pushi12 ; found blank
	tax
	lda qpushok,x
	beq pushi99 ; not OK to push this kind of pieces
	cpx #5
	bne pushi75
	lda <t3
	bne pushi99
pushi75	cpx #6
	bne pushi76
	lda <t2
	bne pushi99
pushi76	lda <t0
	clc
	adc <t2
	cmp #30
	bcs pushi99 ; out of range
	sta <t0
	lda <t1
	adc <t3
	cmp #26
	bcs pushi99 ; out of range
	sta <t1
	bcc pushi00
	; Move each object, in turn
pushi02	ldx <t0
	ldy <t1
	jsr movob
	bcs pushi99 ; unable to move (due to color mismatch, probably)
	lda <t20
	sta <t0
	lda <t21
	sta <t1
pushi12	lda <t0
	ldy <t1
	cpy <t19
	bne pushi03
	cmp <t18
	beq pushi99
pushi03	sec
	sbc <t2
	sta <t0
	tya
	sec
	sbc <t3
	sta <t1
	jmp pushi02
pushi99	rts

	; Destroy at X,Y position (retaining X,Y)
	; Water isn't destoyed, and white wall isn't destroyed, but all
	; other tiles, and all sprites, is destroyed.
destroy	jsr gridad
	lda [t10],y
	ldy <t14
	and #$1F
	cmp #1
	beq destro1
	cmp #15
	beq destro1
	cmp #31
	beq destro1
	lda #0
	jsr upds
destro1	jsr oxyfind
	beq destro2
	lda #$FF
	sta oam,x
	dcp objcnt,y
destro2	ldx <t0
paint9	rts

	; Paint object at X,Y with color A
paint	cpx #30
	bcs paint9
	cpy #26
	bcs paint9
	sta <t9
	cmp #4
	bcs paint8
	sty <t26
	jsr fcolor
	ldy <t9
	lda t4,y
	cmp <t8
	bne paint9
	tya
	ldy <t26
	; Paint it non-white
	jsr gridad
	lda [t10],y
	ldy <t26
	and #$0F
	beq paint9 ; not painting a blank space
	ora #$10
	lsr <t9
	ror <t9
	ror <t9
	ora <t9
	jmp upds
	; Paint it white
paint8	jsr gridad
	lda [t10],y
	ldy <t14
	and #$0F
	jmp upds

	; Move a ball from X,Y in direction <t2,<t3
movball	jsr movob
	bcc movball
	lda <t0
	tax
	cmp #30
	bcs movbal9
	lda <t1
	tay
	cmp #26
	bcs movbal9
	jsr gridad
	lda [t10],y
	and #$0F
	eor #$0F
	bne movbal9
	ldy <t1
	jsr upds
	lda #0
	ldx <t20
	ldy <t21
	jmp upds
movbal9	rts

	; Test a DPCM sample
dpcmkey	ldx #$00
	lda #high(runtitl-1)
	pha
	lda #low(runtitl-1)
	pha
	bit <kdown7
	bvs rundpcm
	inx
	bit <kdown7
	bmi rundpcm
	inx
	bit <kdown6
	bmi rundpcm
	inx
	bit <kdown5
	bmi rundpcm
	inx
	bvs rundpcm
	inx
	bit <kdown4
	bmi rundpcm
	inx
	bvs rundpcm
	inx
	bit <kdown3
	bmi rundpcm
	inx
	bvs rundpcm
	inx
	bit <kdown2
	bmi rundpcm
	rts

	; Play a note on the DPCM channel
rundpcm	txa
	and #$0F
	tax
	lda dpctab,x
	ldy #$16
	sty <dpcnth
	sty <dpcntl
	ldy #$00
rundpc1	tax
	dey
	sty $4011
rundpc2	dec <dpcntl
	bne rundpc3
	dec <dpcnth
	beq rundpc6
rundpc3	pha
	pla
	pha
	pla
	pha
	pla
	dex
	bne rundpc2
	tax
	iny
	sty $4011
rundpc4	dec <dpcntl
	bne rundpc5
	dec <dpcnth
	beq rundpc6
rundpc5	pha
	pla
	pha
	pla
	pha
	pla
	dex
	bne rundpc5
	beq rundpc1
rundpc6	lda #$02
	sta $4011
	rts

	; Macro for jump table of player touching
	macro player_tile
	if ?X=1
	macset 2,4,*
	macset 3,4,?B
	bank 3
	org pmrttl+(\1)
	db low((\2)-1)
	org pmrtth+(\1)
	db high((\2)-1)
	bank \3
	org \2
	endif
	endm
	macro player_sprite
	if ?X=1
	macset 2,4,*
	macset 3,4,?B
	bank 3
	org pmrstl+(\1)
	db low((\2)-1)
	org pmrsth+(\1)
	db high((\2)-1)
	bank \3
	org \2
	endif
	endm
	macro auto_sprite
	if ?X=1
	macset 2,4,*
	macset 3,4,?B
	bank 3
	org autstl+(\1)
	db low((\2)-1)
	org autsth+(\1)
	db high((\2)-1)
	bank \3
	org \2
	endif
	endm

	; X = object sprite number or same as <t16
	; Y = kind of tile or sprite
	; <t0 = destination X
	; <t1 = destination Y
	; <t2 = direction X
	; <t3 = direction Y
	; <t16 = player sprite number
	; <t17 = color
	; <t24 = source X
	; <t25 = source Y

	; Blank space or gate
	player_tile 0
	player_tile 11
	jmp movsp

	; One step
	player_tile 7
	jsr movsp
	ldx <t0
	ldy <t1
	lda #1
	jmp upds

	; Ball
	player_tile 8
	ldx <t0
	ldy <t1
	jmp movball

	; Gem
	player_tile 9
	ldx <t0
	ldy <t1
	lda #0
	jsr upds
	ldx #0
gem1	lda $400,x
	and #$0F
	eor #$09
	beq gem9
	lda $500,x
	and #$0F
	eor #$09
	beq gem9
	lda $600,x
	and #$0F
	eor #$09
	beq gem9
	cpx #$C0
	bcs gem2
	lda $700,x
	and #$0F
	eor #$09
	beq gem9
gem2	inx
	bne gem1
	ldx #0
	jsr rundpcm
	ldx #2
	jsr rundpcm
	ldx #4
	jsr rundpcm
	ldx #7
	jsr rundpcm
	pla
	pla
	inc <levnum
	jmp startle

	; Pushable objects
	player_tile 4
	player_tile 5
	player_tile 6
	player_tile 12
	ldx <t0
	ldy <t1
	jsr pushing
	ldx <t18
	ldy <t19
	jsr gridad
	lda [t10],y
	and #$1F
	bne notpush
gem9	ldx <t16
	jmp movsp
notpush	rts

	; Ghost block
	player_tile 13
	ldx <t0
	ldy <t1
	jsr movob
	bcs notpush
movsp16	ldx <t16
	jmp movsp

	; Paintbrush
	player_tile 10
	ldx <t0
	ldy <t1
	jsr movob
	bcc movsp16 ; if it moves, move the player and stop
	txa
	clc
	adc <t2
	tax
	tya
	clc
	adc <t3
	tay
	lda <t17
	jmp paint

	; Key color translation table
keycol	db 1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0,16

	; Key
	player_tile 2
	ldy <t17
	lda keycol,y
	bit <havekey
	bne immov
	ora <havekey
	sta <havekey
keydo1	jsr movsp
	ldx <t0
	ldy <t1
	lda #0
	jmp upds

	; Door
	player_tile 3
	ldy <t17
	lda keycol,y
	bit <havekey
	beq immov
	eor <havekey
	sta <havekey
	jmp keydo1

	; Immovable, does nothing
	player_tile 1
	player_tile 14
	player_tile 15
	player_sprite 0
	player_sprite 1
	player_sprite 2
	player_sprite 3
	player_sprite 4
	player_sprite 5
	player_sprite 8
	player_sprite 9
	player_sprite 10
	player_sprite 11
	player_sprite 14
	player_sprite 15
	auto_sprite 0
	auto_sprite 1
	auto_sprite 12
	auto_sprite 13
immov	rts

	; Rock
	player_sprite 12
	stx <t8
	lda <t0
	clc
	adc <t2
	tax
	lda <t1
	clc
	adc <t3
	tay
	jsr gridad
	lda [t10],y
	and #$0F
	sta <t7
	beq rock1
	eor #$0F
	bne immov
rock1	ldx <t8
	jsr movsp
	bcs immov
	lda <t7
	beq rock2
	ldy #0
	dcp [t10],y
	ldx <t0
	ldy <t1
	jsr destroy
rock2	ldx <t16
	jmp movsp

	; Deadly pieces
	player_sprite 6
	player_sprite 7
deadly	ldx #7
	jsr rundpcm
	ldx #4
	jsr rundpcm
	ldx #2
	jsr rundpcm
	ldx #0
	jsr rundpcm
	pla
	pla
	jmp startle

	; Bubble
	player_sprite 13
	lda #$FF
	sta oam,x
	ldx <t1
	dec <objcnt,x
	ldx <t16
	jmp movsp

	; X = sprite number
	; Y = kind of tile or sprite
	; <t16 = sprite number
	; <t24 = source X
	; <t25 = source Y

	; Auto moving direction table
autdir	db 0,0,1,255,1,0,0

	; Pusher
	auto_sprite 2
	auto_sprite 3
	auto_sprite 4
	auto_sprite 5
	lda autdir-2,y
	sta <t2
	clc
	adc <t24
	pha
	tax
	lda autdir+1,y
	sta <t3
	clc
	adc <t25
	pha
	tay
	jsr pushing
	pla
	tay
	pla
	tax
	jsr gridad
	lda [t10],y
	and #$0F
	bne pusher0
	ldx <t16
	jmp movsp
pusher0	rts

	; Calculate sign difference between object and player
	; Also find address of grid
signum	lda xplayer
	cmp <t24
	php
	pla
	and #3
	tay
	lda autdir+3,y
	sta <t2
	clc
	adc <t24
	tax
	lda yplayer
	cmp <t25
	php
	pla
	and #3
	tay
	lda autdir+3,y
	sta <t3
	clc
	adc <t25
	tay
	jmp gridad

	; Ghost
	auto_sprite 6
	jsr signum
	cpx xplayer
	bne ghost1
	lda yplayer
	cmp <t14
	bne ghost1
	jmp deadly
ghost1	lda [t10],y
	and #$0F
	eor #$0D
	beq ghost2
	ldx <t16
chaser2	jmp movsp
ghost2	rts

	; Chaser
	auto_sprite 7
	jsr signum
	cpx xplayer
	bne chaser1
	lda yplayer
	cmp <t14
	bne chaser1
	jmp deadly
chaser1	lda [t10],y
	and #$0F
	beq chaser2
	cmp #$07 ; one step
	beq chaser2
	cmp #$0F ; water
	bne chaser3
	ldx <t16
	lda #$FF
	sta oam,x
	ldx <t25
	dec <objcnt,x
chaser5	rts
chaser3	eor #$0D ; ghost block
	bne chaser4
	jmp chaser2
	ldy <t14
	jsr upds
	ldx <t16
	jmp movsp
chaser4	eor #$01 ; bomb
	bne chaser5
chaser6	ldy <t14
	dey
	jsr destroy
	iny
	jsr destroy
	inx
	jsr destroy
	dex
	dex
	jsr destroy
	inx
	iny
	jmp destroy

	; Runner
	auto_sprite 8
	auto_sprite 9
	auto_sprite 10
	auto_sprite 11
	lda autdir-8,y
	sta <t2
	clc
	adc <t24
	tax
	lda autdir-5,y
	sta <t3
	clc
	adc <t25
	tay
	jsr oxyfind
	beq runner4
	lda oam+1,x
	bne runner4
	jmp deadly
runner4	ldx <t0
	ldy <t1
	jsr gridad
	lda [t10],y
	and #$0F
	beq runner1
	cmp #$07 ; one step
	beq runner1
	cmp #$0F ; water
	bne runner2
	ldx <t16
	lda #$FF
	sta oam,x
	ldx <t25
	dec <objcnt,x
runner0	rts
runner1	ldx <t16
	jsr movsp
	bcs runner3
	rts
runner2	cmp #$0C ; bomb
	beq chaser6
	ldx <t16
runner3	lda oam+1,x
	eor #1
	sta oam+1,x
	rts

	; Timer H
	auto_sprite 14
	ldy #1
	sty <t2
	dey
	sty <t3
	jsr movsp
	bcc runner0
	lda #256-29
	sta <t2
	lda #1
	sta <t3
	jsr movsp
	bcc runner0
	jmp deadly

	; Timer V
	auto_sprite 15
	ldy #0
	sty <t2
	iny
	sty <t3
	jsr movsp
	bcc runner0
	lda #256-1
	sta <t2
	lda #256-25
	sta <t3
	jsr movsp
	bcc runner0
	jmp deadly

	bank 3,"Program"

	; Jump table for automatically moving sprites
autstl	= $FF60
autsth	= $FF70

	; Jump table for player touching various objects
pmrttl	= $FF80
pmrtth	= $FF90
pmrstl	= $FFA0
pmrsth	= $FFB0

	; Note periods
	org $FFC0
dpctab	db 180,160,144,135,120,108,96,90,80,72,60,54,45,40,30

	; Is OK to push those kind of pieces?
qpushok	db 0,0,1,0,1,5,3,0,0,1,0,0,1,0,0,0

	; CPU vectors
	org $FFFA
	dw nmi,reset,reset

	; Pattern tables
	;   $00-$0F: Sprites
	;   $10-$1F: Misc
	;   $20-$7F: Text
	;   $80-$BF: Tiles
	; Tiles:
	;   bit7: Always 1
	;   bit6: Always 0
	;   bit5: Background pattern
	;   bit4: Colored if set
	;   bit3-bit0: Kind of tile
	bank 4
	org $0000

	incbin "pc.chr"

	; Cursor picture
	org $0100
	defchr $33332222, \
	       $30000002, \
	       $30000002, \
	       $30010002, \
	       $20001003, \
	       $20000003, \
	       $20000003, \
	       $22223333
	defchr $33332222, \
	       $30000002, \
	       $30000002, \
	       $30010002, \
	       $20001003, \
	       $20000003, \
	       $20000003, \
	       $22223333

	; Tiles

	org $0800 ; Blank
	db %00000000
	db %00000000
	db %00000000
	db %00000000
	db %00010000
	db %00000000
	db %00000000
	db %00000000

	org $0810 ; Wall
	db %00000000
	db %11011111
	db %11011111
	db %11011111
	db %00000000
	db %11110111
	db %11110111
	db %11110111

	org $0820 ; Key
	db %00000000
	db %00000010
	db %00000101
	db %11111101
	db %10100101
	db %10100010
	db %00000000
	db %00000000

	org $0830 ; Door
	db %01111110
	db %11111111
	db %11111111
	db %11110011
	db %11110011
	db %11111111
	db %11111111
	db %01111110

	org $0840 ; Box
	db %00000000
	db %00000000
	db %00111100
	db %00101100
	db %00110100
	db %00111100
	db %00000000
	db %00000000

	org $0850 ; Slider E/W
	db %00000000
	db %00100100
	db %01000010
	db %11111111
	db %01000010
	db %00100100
	db %00000000
	db %00000000

	org $0860 ; Slider N/S
	db %00010000
	db %00111000
	db %01010100
	db %00010000
	db %00010000
	db %01010100
	db %00111000
	db %00010000

	org $0870 ; One Step
	db %00000000
	db %00000001
	db %01010100
	db %00000001
	db %01010100
	db %00000001
	db %01010100
	db %00000000

	org $0880 ; Ball
	db %00000000
	db %00111100
	db %01101110
	db %01011110
	db %01011110
	db %01111110
	db %00111100
	db %00000000

	org $0890 ; Gem
	db %00010000
	db %00101000
	db %01011100
	db %11111110
	db %01111100
	db %00111000
	db %00010000
	db %00000000

	org $08A0 ; Paintbrush
	db %11010100
	db %11111100
	db %10101100
	db %01111000
	db %00110000
	db %00110000
	db %00110000
	db %00110000

	org $08B0 ; Gate
	db %00000000
	db %11111100
	db %00000000
	db %00000000
	db %00111111
	db %00000000
	db %00000000
	db %11111100

	org $08C0 ; Bomb
	db %00011001
	db %00100100
	db %00100001
	db %00010100
	db %00111000
	db %01111100
	db %01111100
	db %00111000

	org $08D0 ; Ghost Block
	db %00000000
	db %01111110
	db %01110010
	db %01101010
	db %01010110
	db %01001110
	db %01111110
	db %00000000

	org $08E0 ; Puller
	db %00100100
	db %00011000
	db %10011001
	db %01110110
	db %01101110
	db %10011001
	db %00011000
	db %00100100

	org $08F0 ; Water
	db %00000000
	db %01100100
	db %10011000
	db %00000000
	db %00110010
	db %01001100
	db %00000000
	db %00000000

	; Sprites

	org $0000 ; Player
	defchr $30011003, \
	       $03111130, \
	       $01211210, \
	       $01111110, \
	       $31222213, \
	       $01111110, \
	       $03030030, \
	       $30030003

	org $0010 ; Other Player
	defchr $30003003, \
	       $03003030, \
	       $01111110, \
	       $31222213, \
	       $01111110, \
	       $01211210, \
	       $03111130, \
	       $30011003

	org $0020 ; Pusher N
	defchr $00000000, \
	       $00030000, \
	       $00313000, \
	       $03111300, \
	       $31121130, \
	       $31111130, \
	       $33333330, \
	       $00000000

	org $0030 ; Pusher S
	defchr $00000000, \
	       $33333330, \
	       $31111130, \
	       $31121130, \
	       $03111300, \
	       $00313000, \
	       $00030000, \
	       $00000000

	org $0040 ; Pusher E
	defchr $00000000, \
	       $03330000, \
	       $03113000, \
	       $03111300, \
	       $03121130, \
	       $03111300, \
	       $03113000, \
	       $03330000

	org $0050 ; Pusher W
	defchr $00000000, \
	       $00003330, \
	       $00031130, \
	       $00311130, \
	       $03112130, \
	       $00311130, \
	       $00031130, \
	       $00003330

	org $0060 ; Ghost
	defchr $00000000, \
	       $00333000, \
	       $03333300, \
	       $30330330, \
	       $33333330, \
	       $33333330, \
	       $33030330, \
	       $30000030

	org $0070 ; Chaser
	defchr $00022000, \
	       $00222200, \
	       $00222200, \
	       $00022002, \
	       $00222222, \
	       $00222200, \
	       $00200200, \
	       $00220222

	org $0080 ; Runner N
	defchr $00033000, \
	       $00300300, \
	       $03022030, \
	       $30200203, \
	       $02011020, \
	       $20100102, \
	       $01000010, \
	       $10000001

	org $0090 ; Runner S
	defchr $10000001, \
	       $01000010, \
	       $20100102, \
	       $02011020, \
	       $30200203, \
	       $03022030, \
	       $00300300, \
	       $00033000

	org $00A0 ; Runner E
	defchr $10203000, \
	       $01020300, \
	       $00102030, \
	       $00010203, \
	       $00010203, \
	       $00102030, \
	       $01020300, \
	       $10203000

	org $00B0 ; Runner W
	defchr $00030201, \
	       $00302010, \
	       $03020100, \
	       $30201000, \
	       $30201000, \
	       $03020100, \
	       $00302010, \
	       $00030201

	org $00C0 ; Rock
	defchr $00121200, \
	       $01212120, \
	       $12121212, \
	       $21212121, \
	       $12121212, \
	       $21212121, \
	       $02121210, \
	       $00212100

	org $00D0 ; Bubble
	defchr $00000000, \
	       $00333000, \
	       $02000300, \
	       $10023030, \
	       $10003030, \
	       $10000030, \
	       $01000200, \
	       $00111000

	org $00E0 ; Timer H
	defchr $33222220, \
	       $33000200, \
	       $00002000, \
	       $00020200, \
	       $00200020, \
	       $02222222, \
	       $00000020, \
	       $00000200

	org $00F0 ; Timer V
	defchr $00000033, \
	       $00200033, \
	       $00220002, \
	       $00202002, \
	       $00200202, \
	       $20202022, \
	       $02220002, \
	       $00200000

	;Level Data
	bank 4
	org $0C00
	incbin "lvldata.0"

	; Postprocessor codes
	emu
	org $8000

	; Fill identity table and editor key tables
postpr	ldx #$00
	stx $2000
	stx $2003
postpr0	txa
	sta $4000,x
	lda $4100,x
	bne postpr1
	lda #high(editkey-1)
	sta $4100,x
	lda #low(editkey-1)
	sta $4200,x
postpr1	inx
	bne postpr0

	; Fill in tile variations
	lda #$04
	sta $2000
tilva	txa
	and #$08
	bne tilva1
	lda $4800,x
	sta $4808,x
	sta $4908,x
	sta $4A08,x
	sta $4B08,x
	ora #$AA
	sta $4A00,x
	eor $4800,x
	sta $4B00,x
	lda #$00
	sta $4900,x
tilva1	inx
	bne tilva

	; Adjust music looping addresses
	lda #$C0
	sta <3
	lda #high(song1)-$40
	sta <1
	lda #low(song1)
	sta <0
	sta <2
	ldx #$00
	stx $2000
muadj	lda [0,x]
	cmp #mushs
	bne muadj1
	lda <0
	sta <2
	inc <0
	lda <1
	eor <3
	sta [0,x]
	jmp muadj3
muadj1	inc <0
	cmp #musl
	bne muadj3
	lda <2
	sta [0,x]
	lda <0
	sta <2
	inc <2
muadj3	inc <0
	bne muadj
	inc <1
	lda <1
	cmp #(high(endsong)&$1F)|$40
	beq ppend
	cmp #$60
	bne muadj
	lda #$E0
	sta <3
	lda #$40
	sta <1
	jmp muadj

	; Stop postprocessor
ppend	hlt

	; Display a hex number to stdout
pphex	php
	pha
	sec
	ror a
	sec
	ror a
	lsr a
	lsr a
	cmp #$3A
	bcc pphex1
	adc #('A'-$3A)-1
pphex1	sta $200A
	pla
	pha
	and #$3F
	ora #$30
	cmp #$3A
	bcc pphex2
	adc #('A'-$3A)-1
pphex2	sta $200A
	lda #' '
	sta $200A
	pla
	plp
	rts

	org $FFFC
	dw postpr

	code
