/*
  Orchestra file for the Attribute Zone music
  [Public domain]
*/

@tempo 2400

@score t0 600

@fxstat 0 @
@fxstat 1 v
@fxstat 2 Z
@fxdis 3 END
@fxstat 4 Q
@fxdis 5 L

@immfx 2
@immfx 3
@immfx 5

@tfx A 2 i2.@C[@a%10] @M 0 @2x
@tfx A 3 i1.@C[@a%10] @M 0 48
@tfx A 5 i1.@C[@a%10] @M 0 52
@channel ABCD

@tno A i3.[@a%10] @T 0 @N @0x @1x
@tno B i4.[@a%10] @T 0 @N @0x @1x
@tno C i5.[@a%10] @T 0 @N @4x
@tno D i6.[@a%10] @T 0 @n @4x @1x @D

@trest A i3.[@a%10] @T 0 63 @0x @1x
@trest B i4.[@a%10] @T 0 63 @0x @1x
@trest C i7.[@a%10] @T 0
@trest D ;

sr = 600
ksmps = 1

@userdefs

fileset "$FILENAME."

giAenv init -999
giBenv init -999
giCenv init -999
giDenv init -999
giZvalue init -999
gistatus init 11
gitimer init 0
gilooped init 0

opcode timeadvance, 0, 0
  i1 init round(p2)
  if gitimer!=i1 then
    if i1-gitimer>255 then
      fileput 50, 255
      gitimer init gitimer+255
    endif
    fileput 50, i1-gitimer
    gitimer init i1
  endif
endop

instr 1 ; End of music / Loop point
  timeadvance
  if gilooped!=p4 then
    gilooped init p4
    fileput p4, 0
  endif
endin

instr 2 ; DPCM value register
  timeadvance
  if giZvalue!=p4 then
    giZvalue init p4
    fileput 17, p4
  endif
endin

instr 3 ; First square channel
  timeadvance
  if p6<0 then
    i1 init p5*64-p6
  else
    i1 init p5*64+48+p6
  endif
  if giAenv!=i1 then
    fileput 0, i1
    giAenv init i1
  endif
  fileput 51, p4*4
endin

instr 4 ; Second square channel
  timeadvance
  if p6<0 then
    i1 init p5*64-p6
  else
    i1 init p5*64+48+p6
  endif
  if giBenv!=i1 then
    fileput 4, i1
    giBenv init i1
  endif
  fileput 51, p4*4+1
endin

instr 5 ; Triangle channel
  timeadvance
  if giCenv!=p5 then
    fileput 8, p5
    giCenv init p5
  endif
  if gistatus==11 then
    gistatus init 15
    fileput 21, 15
  endif
  fileput 51, p4*4+2
endin

instr 6 ; Noise channel
  timeadvance
  if giDenv!=p6 then
    fileput 12, p6+16
    giDenv init p6
  endif
  fileput 14, p4+p7, 15, p5*16+8
endin

instr 7 ; Triangle channel disable
  timeadvance
  if gistatus==15 then
    gistatus init 11
    fileput 21, 11
  endif
endin
