; This program implements the .NSF for the Attribute Zone game.

	code

musl	= $030
mush	= $031
musdel	= $032
musnw	= $033
mushs	= $034

songcnt	= 4

	; Music data
	bank 2,"Music"
	bank 1,"Music"
	org $8000
tone	incbin "tone.bin"
song1	incbin "song1.bin"
song2	incbin "song2.bin"
song3	incbin "song3.bin"
song4	incbin "song4.bin"
	ds low(256-*) ; Skip to next 256-byte page
endsong	= *

musptrl	db low(song1),low(song2),low(song3),low(song4)
musptrh	db high(song1),high(song2),high(song3),high(song4)

	; Program
	bank 3
	org $C000

init	eor #$00
	tax
	lda musptrl,x
	sta <musl
	lda musptrh,x
	sta <mush
	tay
	lda #$4B
	sta $4015
	sta $4017
	lda #$10
	sta <musdel
	sta $4000
	sta $4004
	sta $400C
	lsr a
	sta $4001
	sta $4005
	sty <mushs
	rts

play	lda <musdel
	beq mus1
	dec <musdel
	rts
mus1	tay
	lda [musl],y
	tax
	inc <musl
	lda [musl],y
	inc <musl
	bne mus2
	inc <mush
mus2	cpx #musl
	bcs mus3
	sta $4000,x
mus3	sta <0,x
	cpx #musl
	bne mus4
	lda <mushs
	sta <mush
mus4	cpx #musnw
	bne play
	; Load current musical note
	lsr a
	lsr a
	tax
	lda <musnw
	and #$03
	asl a
	asl a
	tay
	lda tone,x
	sta $4002,y
	lda tone+64,x
	sta $4003,y
	jmp play

	; NSF header data
	bank 0
	org $0000
	db "NESM", $1A, $01, songcnt, $01 ; version, total, starting
	dw $8000, init, play ; load/init/play address
	db "Attribute Zone", $00 ; title
	ds 17
	db "Aaron Black", $00 ; composer
	ds 20
	db "<?>", $00 ; maker
	ds 28
	dw 16639 ; play speed (NTSC)
	db $00, $00, $00, $00, $00, $00, $00, $00 ; bank init
	dw 19997 ; play speed (PAL)
	db $00, $00, $00, $00, $00, $00 ; TV, chip, 4x reserved

	; NSF format writing postprocessor
	emu X
	org $FFFC
	dw post
	org $8000

	; Adjust music looping addresses
post	lda #$C0
	sta <3
	lda #high(song1)-$40
	sta <1
	lda #low(song1)
	sta <0
	sta <2
	ldx #$01
	stx $2000
	dex
muadj	lda [0,x]
	cmp #mushs
	bne muadj1
	lda <0
	sta <2
	inc <0
	lda <1
	eor <3
	sta [0,x]
	jmp muadj3
muadj1	inc <0
	cmp #musl
	bne muadj3
	lda <2
	sta [0,x]
	lda <0
	sta <2
	inc <2
muadj3	inc <0
	bne muadj
	inc <1
	lda <1
	cmp #(high(endsong)&$1F)|$40
	beq wnsfhd
	cmp #$60
	bne muadj
	lda #$E0
	sta <3
	lda #$40
	sta <1
	jmp muadj

	; Write .NSF header
wnsfhd	lda #$00
	sta $2000 ; bank number
	sta $2007 ; bank output length high byte
	lda #$80
	sta $2006 ; bank output length low byte
	sta $2008 ; write bank to output file

	; Write data and program ROM
	lda #$20
	sta $2007
	lda #$00
	sta $2006
	inc $2000
	sta $2008
	inc $2000
	sta $2008
	inc $2000
	sta $2008

	hlt

	code
