/*
  This program is part of Attribute Zone and is in the public domain.

  The function of this program is to copy only the 2K internal RAM available to the CPU,
  taken from a quick save state from a Famicom emulator, into another file.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char outname[32]="level/";
static FILE*infp;
static FILE*outfp;
static const char signature[16]={0,0,0,0,0,'A','A','R','O','N','.','B','L','A','C','K'};
static char buf[16];
static int i;

int main(int argc,char**argv) {
  if(argc!=3) return 1;
  strcat(outname,argv[2]);
  infp=fopen(argv[1],"rb");
  if(!infp) return 1;
  outfp=fopen(outname,"wb");
  if(!outfp) return 1;
  fseek(infp,0x1F0,SEEK_SET);
  while(!feof(infp)) {
    if(!fread(buf,1,16,infp)) return 1;
    for(i=0;i<16 && memcmp(buf,signature+i,16-i);i++);
    if(!i) break;
    if(i!=16) fseek(infp,-(i+16),SEEK_CUR);
  }
  fseek(infp,-512,SEEK_CUR);
  for(i=0;i<0x80;i++) {
    fread(buf,1,16,infp);
    fwrite(buf,1,16,outfp);
  }
  fclose(infp);
  fclose(outfp);
  return 0;
}
